<?php
// $Id: webshow_links.php,v.50 2007/03/01 19:59:00 tcnet Exp $ //
//  ------------------------------------------------------------------------ //
//                XOOPS - PHP Content Management System                      //
//                    Copyright (c) 2000 XOOPS.org                           //
//                       <http://www.xoops.org/>                             //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
/******************************************************************************
 * Function: b_webshow_links_show
 * Input   : $options[0] = Sort playlist links by date, hits, rating and random.
 *           $options[1]   = How many playlist links will be displayed.
  *           $options[2]   = Number of columns wide
   *           $options[3]   = Length of playlist title. 0 = Titles off.. 
    *           $options[4]   = Show link logo image.
    *           $options[5]   = Limit to selected category.
    *           $options[6]   = Show link statistics by selected sort.        
 * Output  : Returns the desired most recent, popular, rated or random links
 ******************************************************************************/
if (!defined('XOOPS_ROOT_PATH')){ exit(); }

function b_webshow_links_show($options) {
global $xoopsDB, $xoopsModule, $xoopsModuleConfig;
$block = array();
$myts =& MyTextSanitizer::getInstance();
$path_logo = XOOPS_URL."/uploads/webshow/logo";

//** Limit to category
 if($options[5] == "0") {
    $result = $xoopsDB->query("SELECT lid, cid, title, logourl, date, hits, rating, votes FROM ".$xoopsDB->prefix("webshow_links")." WHERE status>0 and cid>0 ORDER BY ".$options[0]." DESC",$options[1],0);
 } else {
    $result = $xoopsDB->query("SELECT lid, cid, title, logourl, date, hits, rating, votes FROM ".$xoopsDB->prefix("webshow_links")." WHERE cid = ".$options[5]." and status>0 ORDER BY ".$options[0]." DESC",$options[1],0);			
 }		
while($myrow = $xoopsDB->fetchArray($result)){
   $link = array();
   $link['id'] = $myrow['lid'];
   $link['cid'] = $myrow['cid'];
   //** TITLE
   if ($options[3] > 0) {				
      $title = $myts->makeTboxData4Show($myrow["title"]);
	if (strlen($title) >= $options[3]) {
	   $title = $myts->makeTboxData4Show(substr($title,0,($options[3] -1)))."...";
	}  //By Marcan
   $link['title'] = "<a href=\"".XOOPS_URL."/modules/webshow/singlelink.php?lid=".$link['id']."\" target=\"_self\" title=\""._MB_WEBSHOW_WEBCAST.": ".$title."\">".$title."</a>";
   } else {
   $link['title'] = "";
   }

   //** SHOW ENTRY LOGO
      $logourl = $myrow['logourl'];     
   if ( $options[4] == 1 & $logourl != "") {	  
      $ps = strpos($logourl,"http://");
      if($ps === false) {      
         $logourl = $path_logo."/".$logourl;
      }     
      $link['logo'] = "<a href=\"".XOOPS_URL."/modules/webshow/singlelink.php?lid=".$link['id']."\" target=\"_self\"><img src=\"".$logourl."\" alt=\"".$title."\" /></a>";
   } else {
       $link['logo'] = "";
   }

//** OPTION6 Show the link statistics by sort method
     if ( $options[6] == 1) {
         $link['stats'] = $options[6];
	  if($options[0] == "date"){
		  $link['date'] = formatTimestamp($myrow['date'],'s');
	  } elseif ($options[0] == "hits") {
		  $link['hits'] =  "("._MB_WEBSHOW_HITS.": ".$myrow['hits'].")";
	  } elseif ($options[0] == "rating") {
		  $link['rating'] = "("._MB_WEBSHOW_RATING.": ".$myrow['rating'].")";
		  $link['votes'] = "("._MB_WEBSHOW_VOTES.": ".$myrow['votes'].")";
	  }
	}
  $block['links'][] = $link;
  }
$block['columncount'] = $options[2];
return $block;
}

function b_webshow_links_edit($options) {
global $xoopsDB, $xoopsConfig;
include_once XOOPS_ROOT_PATH."/class/xoopstree.php";

    $form = ""._MB_WEBSHOW_SORT."&nbsp;<select name='options[]'>";
    $form .= "<option value='date' ";
    if ( $options[0] == "date" ) {
        $form .= " selected='selected'";
    }
    $form .= ">"._MB_WEBSHOW_DATE."</option>\n";
    $form .= "<option value='hits'";
    if($options[0] == "hits"){
        $form .= " selected='selected'";
    }
    $form .= ">"._MB_WEBSHOW_HITS."</option>";
    $form .= "<option value='rating'";
    if ( $options[0] == "rating" ) {
        $form .= " selected='selected'";
    }
    $form .= ">" . _MB_WEBSHOW_RATING . "</option>";
    $form .= "</select>\n";
    $form .= "<br /><br />"._MB_WEBSHOW_DISP."&nbsp;<input type='text' name='options[1]' value='".$options[1]."'/>&nbsp;"._MB_WEBSHOW_LINKS."<br /><br />";
    $form .= _MB_WEBSHOW_DISP." <input type='text' name='options[2]' value='".$options[2]."' />&nbsp;"._MB_WEBSHOW_COLUMNSWIDE."<br /><br />";
    $form .= _MB_WEBSHOW_CHARS."&nbsp;<input type='text' name='options[3]' value='".$options[3]."'/>&nbsp;"._MB_WEBSHOW_LENGTH."<br /><br />";
    //** OPTION4 Show Logo
    $form .= _MB_WEBSHOW_SHOWLINKLOGO."&nbsp;&nbsp;<input type='radio' name='options[4]' value='1'";
    if ($options[4] == 1) {
        $form .= " checked='checked'";
    }
    $form .= " />"._YES;
    $form .= "<input type='radio' name='options[4]' value='0'";
    if ($options[4] == 0) {
      $form .= " checked='checked'";
    }
    $form .= " />"._NO."<br /><br />";
    
    //**Category Select
	$cattree = new XoopsTree($xoopsDB->prefix("webshow_cat"),"cid","pid");    
	$form .=_MB_WEBSHOW_CATLIMIT;	
	ob_start();
	//**EXAMPLE makeMySelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange="")			
	$cattree->makeMySelBox("cattitle", "cattitle",$options[5],1,'options[5]');
	$catselbox = ob_get_contents();
	ob_end_clean();
	$form .= $catselbox;
    
    //** OPTION6 Show the link statistics
    $form .= "<br /><br />"._MB_WEBSHOW_SHOWLINKSTATS."&nbsp;&nbsp;&nbsp;<input type='radio' name='options[6]' value='1'";
    if ($options[6] == 1) {
        $form .= " checked='checked'";
    }
    $form .= " />"._YES;
    $form .= "<input type='radio' name='options[6]' value='0'";
    if ($options[6] == 0) {
      $form .= " checked='checked'";
    }
    $form .= " />"._NO;
    return $form;
}
?>